<?php
namespace nulib\schema;

use nulib\ValueException;

class ConsolidatedResult extends Result {
  function addMissingMessage(Wrapper $wrapper): void {
    $this->resultAvailable = true;
    $this->present = false;
    $this->available = false;
    $this->null = false;
    $this->valid = false;
    $this->messageKey = "missing";
    $result = $wrapper->getResult();
    $resultException = $result->exception;
    $resultMessage = $result->message;
    if ($resultException !== null) {
      $tmessage = ValueException::get_message($resultException);
      if ($tmessage) {
        if ($resultMessage !== null) $resultMessage .= ": ";
        $resultMessage .= $tmessage;
      }
    }
    $message = $this->message;
    if ($message) $message .= "\n";
    $message .= $resultMessage;
    $this->message = $message;
  }

  function addUnavailableMessage(Wrapper $wrapper): void {
    $this->resultAvailable = true;
    $this->present = true;
    $this->available = false;
    $this->null = false;
    $this->valid = false;
    $this->messageKey = "unavailable";
    $result = $wrapper->getResult();
    $resultException = $result->exception;
    $resultMessage = $result->message;
    if ($resultException !== null) {
      $tmessage = ValueException::get_message($resultException);
      if ($tmessage) {
        if ($resultMessage !== null) $resultMessage .= ": ";
        $resultMessage .= $tmessage;
      }
    }
    $message = $this->message;
    if ($message) $message .= "\n";
    $message .= $resultMessage;
    $this->message = $message;
  }

  function addNullMessage(Wrapper $wrapper): void {
    $this->resultAvailable = true;
    $this->present = true;
    $this->available = true;
    $this->null = true;
    $this->valid = false;
    $this->messageKey = "null";
    $result = $wrapper->getResult();
    $resultException = $result->exception;
    $resultMessage = $result->message;
    if ($resultException !== null) {
      $tmessage = ValueException::get_message($resultException);
      if ($tmessage) {
        if ($resultMessage !== null) $resultMessage .= ": ";
        $resultMessage .= $tmessage;
      }
    }
    $message = $this->message;
    if ($message) $message .= "\n";
    $message .= $resultMessage;
    $this->message = $message;
  }

  function addInvalidMessage(Wrapper $wrapper): void {
    $this->resultAvailable = true;
    $this->present = true;
    $this->available = true;
    $this->null = false;
    $this->valid = false;
    $this->messageKey = "invalid";
    $result = $wrapper->getResult();
    $resultException = $result->exception;
    $resultMessage = $result->message;
    if ($resultException !== null) {
      $tmessage = ValueException::get_message($resultException);
      if ($tmessage) {
        if ($resultMessage !== null) $resultMessage .= ": ";
        $resultMessage .= $tmessage;
      }
    }
    $message = $this->message;
    if ($message) $message .= "\n";
    $message .= $resultMessage;
    $this->message = $message;
  }
}
